const formatDate = (value) => {
    if (value) {
        return new Date(value).toLocaleString('en-US', {
            month: 'numeric',
            day: 'numeric',
            year: 'numeric',
        });
    }
};

const truncate = (text, length, clamp) => {
    clamp = clamp || '...';
    var node = document.createElement('div');
    node.innerHTML = text;
    var content = node.textContent;
    return content.length > length ? content.slice(0, length) + clamp : content;
};

export { formatDate };
export { truncate };
export default {
    formatDate,
    truncate,
};
